class Spell
{
public:
  // member functions

//  Spell(char *, int); // constructor
  ~Spell(); // destructor

  void newSpell(char *, int);
  char * retName();
  int retSC();
  int retSkill();
  int retExp();

  void incSkill(int);
  void incExp(int);

  void setActivated(int);
  int  retActivated();

private:
  char name[20];
  char spellcost;
  int  skill;
  int exp;
  int activated;
};

/*
Spell :: Spell(char * spellname, int cost)
{
  strcpy(name, spellname);
  spellcost = cost;
  skill = 1;
  exp = 0;
}
*/

Spell :: ~Spell()
{
}

void Spell :: newSpell(char * spellname, int cost)
{
  strcpy(name, spellname);
  spellcost = cost;
  skill = 1;
  exp = 0;
  activated = 0;
}

char * Spell :: retName()
{
  return (name);
}

// return spellcost
int Spell :: retSC()
{
  return (spellcost);
}

// return skill
int Spell :: retSkill()
{
  return (skill);
}

// return exp (experience)
int Spell :: retExp()
{
  return (exp);
}

// increment skill by the parameter num
void Spell :: incSkill(int num)
{
  skill = skill + num;
}

// increment exp by the parameter num
void Spell :: incExp(int num)
{
  exp = exp + num;
}

void Spell :: setActivated(int num)
{
  activated = num;
}

int Spell :: retActivated()
{
  return (activated);
}
