/*  room1.h - Dungeon
 *  File created: June 1999
 *  Last modified: 12. August 1999
 */

#include <iostream.h>
#include <stdlib.h>

void init1(char string[]);
void desc1(Room []);
void look1(Room [], char [], char []);
void search1(char [], Myr &);
void open1(Room [], char [], char []);
void cast1(Myr &, char [], char [], Room []);
void take1(Myr &, Room [], char [], char []);

void room1(Myr & wytch, Room rooms[], int & setroom)
{
  // declare variables
  char command[25], token[10], token2[10], token3[10], token4[10];
  char breakloop[4] = "";

  desc1(rooms);

  do
  {

  printf("\n> ");

  /* initialize the tokens */
  init1(token);
  init1(token2);
  init1(token3);
  init1(token4);

  gets(command);
  sscanf(command, "%s %s %s %s", token, token2, token3, token4);

  if (!strcmp(command, "exit game") || !strcmp(command, "quit game"))
  {
    strcpy(breakloop, "bye");
    setroom = 100;
  }
  else if (!strcmp(token, "quit"))
  {
    strcpy(breakloop, "bye");
    setroom = 100;
  }
  else if (!strcmp(command, "stats"))
    wytch.stats();
  else if (!strcmp(command, "i") || !strcmp(command, "inventory"))
    wytch.printInv();
  else if (!strcmp(command, "help"))
    help();
  else if (!strcmp(command, "tutorial"))
    tutorial();
  else if (!strcmp(command, "save") || !strcmp(command, "save game"))
    savegame(setroom, wytch, rooms);
  else if (!strcmp(command, "restore") || !strcmp(command, "restore game"))
    restoregame(setroom, wytch, rooms, breakloop);
  else if (!strcmp(token, "n") || !strcmp(token, "north"))
  {
    if (rooms[1].retPrevRoom() == 2)
    {
      rooms[1].doFunct(1, "openDoor");
      cout << "You leave the dungeon and ascend the stairs." << endl;
      rooms[1].setPrevRoom(1);
      setroom = 2;
      strcpy(breakloop, "bye");
    }
    else if (rooms[1].doFunct2(1, "isClosed") == 1)
      cout << "Try opening the door first." << endl;
    else
    {
      cout << "You leave the dungeon behind and ascend the stairs." <<
      endl;
      rooms[1].setPrevRoom(1);
      setroom = 2;
      strcpy(breakloop, "bye");
    }
  }
  else if (!strcmp(token, "u") || !strcmp(token, "up"))
  {
    if (rooms[1].retPrevRoom() == 2)
    {
      rooms[1].doFunct(1, "openDoor");
      cout << "You leave the dungeon and ascend the stairs." << endl;
      rooms[1].setPrevRoom(1);
      setroom = 2;
      strcpy(breakloop, "bye");
    }
    else if (rooms[1].doFunct2(1, "isClosed") == 1)
      cout << "Try opening the door first." << endl;
    else
    {
      rooms[2].setPrevRoom(1);
      rooms[1].setMiscvar(0, 1); // the room has now been visited
      strcpy(breakloop, "bye");
      setroom = 2;
      cout << "You leave the dungeon behind and ascend the stairs." <<
      endl;
    }
  }
  else if (!strcmp(token, "s") || !strcmp(token, "south"))
  {
    if (wytch.retCircle() != 4)
      rooms[1].setMiscvar(0, 1);

    if (rooms[1].getMiscvar(0) == 0)
    {
      if (wytch.searchInv("iron key") != 0)
      {
        cout << "You unlock the door and go inside the cell." << endl;
        rooms[0].setPrevRoom(1);
        rooms[0].doFunct(3, "unlockDoor");
	rooms[0].doFunct(3, "openDoor");
        rooms[1].setMiscvar(0, 1); // the room has now been visited
        strcpy(breakloop, "bye");
        setroom = 0;
      }
      else
        cout << "You test the door to find it locked." << endl;
    }
    else
    {
        cout << "You return to the prison cell." << endl;
        rooms[0].setPrevRoom(1);
        rooms[1].setMiscvar(0, 1); // the room has now been visited
        strcpy(breakloop, "bye");
        setroom = 0;
    }
  }
  else if (!strcmp(token, "w") || !strcmp(token, "west"))
    cout << "You can't go in that direction." << endl;
  else if (!strcmp(token, "e") || !strcmp(token, "east"))
  {
    cout << "You walk down the short hall, but don't achieve anything" <<
    endl << "in the process so you walk back to the west end of the" <<
    endl << "hall." << endl;
  }
  else if (!strcmp(token, "look"))
    look1(rooms, token2, token3);
  else if (!strcmp(token, "search"))
    search1(token2, wytch);
  else if (!strcmp(token, "open"))
    open1(rooms, token2, token3);
  else if (!strcmp(token, "close"))
  {
    if (!strcmp(token2, "door"))
    {
      if (rooms[1].doFunct2(1, "isClosed") == 1)
        cout << "The door is already closed, you dimwit." << endl;
      else
      {
        cout << "You close the door." << endl;
        rooms[1].doFunct(1, "closeDoor");
      }
    }
  }
  else if (!strcmp(token, "get") || !strcmp(token, "take"))
    take1(wytch, rooms, token2, token3);
  else if (!strcmp(token, "drink") && !strcmp(token2, "water"))
  {
    cout << "You are instantly repulsed in even thinking about drinking any"<<
    endl << "of the putrid water trickling along the walls." << endl;
  }
  else if (!strcmp(token, "drink"))
    drink(wytch, token2, token3, 4); // 4 is just a general number for now
  else
    cout << "That did not make sense." << endl;

  }
  while(strcmp(breakloop, "bye") != 0);
}

/*********************************************************
 * init1(char string[])                                  *
 * initialize the tokens to clear them out               *
 ********************************************************/
void init1(char string[])
{
  for (int i = 0; i < 10; i++)
    string[i] = '\0';
}


void desc1(Room rooms[])
{ 
  cout <<
  endl << "You hear the hushed trickle of water as you step into a "<<
  endl << "a narrow hallway which runs from east to west. There" <<
  endl << "is a door to the north, and three prison cells behind"<<
  endl << "you to the south.";

  if (rooms[1].searchItem("iron key") != 0)
  {
    cout << " There is an iron key hanging on a hook" << 
    endl << "next to the door.";
  }

  cout << endl;
}

void look1(Room rooms[], char token2[], char token3[])
{
  if (!strcmp(token2, "prisons") || !strcmp(token2, "cells"))
  {
    cout << "The prison cell you exited from is the only semi-" <<
    endl << "servicable cell of the three since the other two " <<
    endl << "have been boarded up and walled over, so there is " <<
    endl << "easy way to gain access to the other two cells." << endl;
  }
  else if (!strcmp(token2, "doors") || !strcmp(token2, "door"))
  {
    cout << "There are two doors in this room.  One to the north, " <<
    endl << "and one to the south, which leads back to the prison" <<
    endl << "you were trapped in.";
    if (rooms[1].searchItem("iron key") != 0)
      cout << "  There is an iron key hanging next to the door." << endl;
    else
      cout << endl;
  }
  else if (!strcmp(token2, "key") || !strcmp(token2, "iron"))
  {
    if (rooms[1].searchItem("iron key") != 0)
      cout << "It is an old, worn key hanging next to the door." << endl;
    else
      cout << "You see no key here." << endl;
  }
  else if (!strcmp(token2, "wall") || !strcmp(token2, "walls"))
  {
    cout << "The walls are moist from the water trickling down from the"<<
    endl << "crack in the ceiling." << endl;
  }
  else if (!strcmp(token2, "water"))
  {
    cout << "Water is trickling down along the walls from the cracks in the"<<
    endl << "ceiling.  You briefly consider trying to drink some of the " <<
    endl << "but quickly change your mind, guessing that the water might" <<
    endl << "be tainted." << endl;
  }
  else if (!strcmp(token2, "room"))
    desc1(rooms);
  else
    desc1(rooms);  
}

void search1(char token2[], Myr & wytch)
{
  if (!strcmp(token2, "ground") || !strcmp(token2, "floor") || !strcmp(token2, "comwebs"))
  {
    cout << "Ohmygawd!  While searching the ground, buried in a " <<
    endl << "mound of cob webs you find a used Pez dispenser with " <<
    endl << "a rare edition Felix-the-Cat head on it!  You pick up" <<
    endl << "this obvious red herring devise and put it carefully " <<
    endl << "away in your satchel." << endl;
    wytch.insertInv("Pez dispenser", 1);
  }
  else if (!strcmp(token2, "room"))
    cout << "You find nothing in the room except some cobwebs on the " <<
    endl << "dusty floor" << endl;
  else
  {
    cout << "Your search proves fruitless...I mean it, you don't find " <<
    endl << "any fruit...much less of anything else that you might have"<<
    endl << "been looking for." << endl;
  }
}

void open1(Room rooms[], char token2[], char token3[])
{
  if (!strcmp(token2, "door") || !strcmp(token3, "door"))
  {
    if (rooms[1].doFunct2(1, "isClosed") == 1)
    {
      rooms[1].doFunct(1, "openDoor");
      cout << "You open the door to reveal a stairway leading up " <<
      endl << "to another floor." << endl;
    }
    else
    {
      cout << "The door is already open.  Try making better use of your"<<
      endl << "time instead of wasting it on trivial tasks you've already"<<
      endl << "completed." << endl;
    }
  }
}


void cast1(Myr & wytch, char token2[], char token3[], Room rooms[])
{
  int casted = 0; // initially the spell has not been cast yet

  // concatenate token2 & token 3
  if (strcmp(token3, "\0")) // if token3 is not NULL
  {
    strcat(token2, " ");
    strcat(token2, token3);
  }

  wytch.castSpell(token2, casted);

  if (casted == 1)
  {
    if (!strcmp(token2, "Sense") || !strcmp(token2, "History"))
    {
      cout << "You can sense the pain and agony embedded into this" <<
      endl << "place.  However, your spell tells you nothing highly" <<
      endl << "relavent about this hallway." << endl;
    }
    else  if (!strcmp(token2, "Translate"))
    { 
      cout << "You cast the Translate spell.  You now have the "<<
      endl << "ability to read strange and foreign languages." <<
      endl;
    }
    else
    {
      cout << "While there is no use for your spell here, you do get" <<
      endl << "in some practice." << endl;
    } 
  }
}

void take1(Myr & wytch, Room rooms[], char token2[], char token3[])
{
  if (!strcmp(token2, "iron"))
    strcpy(token2, token3);

  if (!strcmp(token2, "key") || !strcmp(token2, "keys"))
  {
    if (wytch.retCircle() == 4 && rooms[1].searchItem("iron key") != 0)
    {
      wytch.insertInv("iron key", 1);
      rooms[1].removeItem("iron key");
      cout << "You take the key from its hook off the wall and put it in" <<
      endl << "one of your pockets." << endl;
    }
    else
      cout << "You see no keys here." << endl;
  }
  else if (!strcmp(token2, "water"))
  {
    if (wytch.searchInv("empty flask") != 0)
    {
      cout << "Using your empty flask, you collect some of the putrid water"<<
      endl << "trickling down the walls." << endl;
      wytch.removeInv("empty flask");
      wytch.insertInv("flask of water", 1);
    }
    else
    {
      cout << "You don't have a suitable container in which to hold the the"<<
      endl << "the water." << endl;
    }
  }
  else
    cout << "You see no " << token2 << " here.  Try looking at Salvation Army instead." << endl;
}
