/* room12.h - Mordekai Prayer Room 
 * Created: 1. August 1999 
 * Last modified: 5. August 1999
 */

#include <iostream.h>
#include <stdlib.h> // necessary for exit(1)
#include <stdio.h>

void init12(char string[]);
void desc12();
void look12(Room [], char [], char [], char []);
void cast12(Myr &, char [], char []);
void take12(Myr &, Room [], char [], char []);
void move12(char [], char []);

void room12(Myr & wytch, Room rooms[], int & setroom)
{
  char command[44], token[10], token2[10], token3[10], token4[10];
  char breakloop[4] = "";

  cout << 
  endl << "As soon as you step into this room, a shiver bolts down your "<<
  endl << "spine due to the chill and evil emanating from this room." << endl;
  wytch.modLife(-1); // LP taken away due to evil presence
  desc12();


  do
  {

    printf("\n> ");

    /* initialize the tokens */
    init(token);
    init(token2);
    init(token3);
    init(token4);

    gets(command);
    sscanf(command, "%s %s %s %s", token, token2, token3, token4);

    /* Scan the command for any useless words */
    scanprep(token, token2, token3, token4);

    if (!strcmp(token, "exit") && !strcmp(token2, "game"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "quit"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "help"))
      help();
    else if (!strcmp(token, "tutorial"))
      tutorial();
    else if (!strcmp(command, "save") || !strcmp(command, "save game"))
      savegame(setroom, wytch, rooms);
    else if (!strcmp(command, "restore") || !strcmp(command, "restore game"))
      restoregame(setroom, wytch, rooms, breakloop);
    else if (!strcmp(token, "i") || !strcmp(token, "inventory"))
      wytch.printInv();
    else if (!strcmp(token, "stats"))
      wytch.stats();
    else if (!strcmp(token, "e") || !strcmp(token, "east"))
    {
      cout << "You leave the prayer room." << endl;
      rooms[10].setPrevRoom(12);
      setroom = 10;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "n") || !strcmp(token, "north"))
      cout << "You can't go in that direction." << endl;
    else if (!strcmp(token, "s") || !strcmp(token, "south"))
      cout << "You can't go in that direction." << endl;
    else if (!strcmp(token, "w") || !strcmp(token, "west"))
      cout << "You can't go in that direction." << endl;
    else if ((!strcmp(token, "fuck")) || (!strcmp(token, "shit")))
    {
      cout << "Well, if that's the way you're going to be..." << endl;
      exit(1);
    }
    else if (!strcmp(token, "asshole"))
    {
      cout << "This game doesn't tolerate such foul language." << endl;
      exit(1);
    }
    else if (!strcmp(token, "look"))
    {
      look12(rooms, token2, token3, token4);
    }
    else if (!strcmp(token, "cast"))
    {
      cast12(wytch, token2, token3);
    }
    else if (!strcmp(token, "get") || !strcmp(token, "take"))
      take12(wytch, rooms, token2, token3);
    else if (!strcmp(token, "move"))
      move12(token2, token3);
    else if (!strcmp(token, "drink"))
      drink(wytch, token2, token3, 4); // 4 is just a general number for now
    else if (!strcmp(token, "pray") || !strcmp(token, "kneel"))
    {
      cout << "You shudder to think of paying any homage to such a vile " <<
      endl << "Immortal such as Mordekai." << endl;
    }
    else if (!strcmp(token, "stand"))
      cout << "You are already standing!" << endl;
    else if (!strcmp(token, "drop"))
    {
      wytch.removeInv(token2);
      rooms[12].insertItem(token2, 1);
    }

    else
      cout << "";
  }
  while(strcmp(breakloop, "bye") != 0);
}

/*********************************************************
 * init12(char string[])                                *
 * initialize the tokens to clear them out               *
 ********************************************************/
void init12(char string[])
{
  for (int i = 0; i < 10; i++)
    string[i] = '\0';
}


/*********************************************************
 * desc12()                                              *
 * Gives the room description                            *
 ********************************************************/
void desc12()
{
  cout <<
  endl << "You are in a small, dark prayer room.  Tall candelabras act as" <<
  endl << "sentinels on each side of a low altar near the center of the "<<
  endl << "room.  A long tapestry decorates the back wall of the small "<<
  endl << "room." <<
  endl;
}


/*********************************************************
 * look12()                                             *
 ********************************************************/
void look12(Room rooms[], char token2[], char token3[], char token4[])
{
  if (!strcmp(token2, "tapestry") || !strcmp(token2, "wall"))
  {
    if (rooms[3].getMiscvar(0) == 0)
    {
      cout << "The tapestry bears a large complex Q-shaped symbol on it." <<
      endl << "You wonder about the significance of it in this room." << endl;
    }
    else
    {
      cout << "The long tapestry is fairly simple except for the complex"<<
      endl << "Q-design which you recognize as the symbol of Angwyn." << endl;
    }
  }
  else if (!strcmp(token2, "candelabra") || !strcmp(token2, "candelabras"))
  {
    cout << "Two lit candelabras stand on each side of the altar." << endl;
  }
  else if (!strcmp(token2, "altar"))
  {
    if (rooms[12].searchItem("amulet") != 0)
    {
      cout << "The altar has a cloth draped over it, embossed with the "<<
      endl << "symbol of Mordekai, the Dark Immortal.  There is an amulet "<<
      endl << "laying on the altar." << endl;
    }
    else
    {
      cout << "The altar has a cloth draped over it, embossed with the" <<
      endl << "symbol of Mordekai, the Dark Immortal." << endl;
    }
  }
  else if (!strcmp(token2, "cloth"))
  {
    cout << "The cloth is made of a dark purple velvet, albeit heavily" <<
    endl << "ragged and aged.  The symbol of Mordekai is stitched into" <<
    endl << "the fabric." << endl;
  }
  else if (!strcmp(token2, "symbol") || !strcmp(token2, "symbols"))
  {
    cout << "You see two symbols in this room; an intricate Q-shaped" <<
    endl << "symbol on the tapestry hanging on the wall, and the " <<
    endl << "symbol of Mordekai which looks like a disfigured Y, " <<
    endl << "encompassed by a circle." << endl;
  }
  else if (!strcmp(token2, "amulet") || !strcmp(token3, "amulet"))
  {
    if (rooms[12].searchItem("amulet") != 0)
    {
      cout << "The amulet with a mushroom shape on it.  From what you"<<
      endl << "recall about the legends and history of Mordekai, the" <<
      endl << "mushroom is one of the many symbols representing the " <<
      endl << "Dark Immortal." << endl;
    }
    else
      cout << "You don't see an amulet here." << endl;
  }
  else if (!strcmp(token2, "room"))
    desc12();
  else
    desc12();
}


/*********************************************************
 * cast12()                                             *
 ********************************************************/
void cast12(Myr & wytch, char token2[], char token3[])
{
  int casted = 0; // initially the spell has not been cast yet

  // concatenate token2 & token 3
  if (strcmp(token3, "\0")) // if token is not NULL
  {
    strcat(token2, " ");
    strcat(token2, token3);
  }

  wytch.castSpell(token2, casted);

  if (casted == 1)
  {
    if (!strcmp(token2, "Sense"))
      cout << "You sense a great deal of Evil coming from this room." << endl;
    else
    {
      cout << "While you got in some good practice, your spell wasn't " <<
      endl << "necessarily useful here." << endl;
    }
  }
}

void take12(Myr & wytch, Room rooms[], char token2[], char token3[])
{
  if (!strcmp(token2, "amulet") || !strcmp(token3, "amulet"))
  { 
    if (rooms[12].searchItem("amulet") != 0)
    {
    cout << "You pick up the amulet and slip it over your neck." << endl;
    wytch.insertInv("amulet", 1);
    rooms[12].removeItem("amulet");
    }
    else
      cout << "You don't see any amulet here." << endl;
  }
  else if (!strcmp(token2, "candelabra") || !strcmp(token2, "candelabras"))
    cout << "You don't need a candelabra." << endl;
  else if (!strcmp(token2, "tapestry"))
  {
    cout << "You don't have the space in your backpack to carry that " <<
    endl << "tapestry around with you." << endl;
  }
  else if (!strcmp(token2, "altar"))
  {    
    cout << "Come on, get serious!  Even if there was a way to break the" <<
    endl << "altar away from the floor, you certainly don't have the" <<
    endl << "strength to lug an entire altar around for the rest of the game."
  <<endl;
  }
  else if (!strcmp(token2, "cloth"))
  {
    cout << "You don't seen any real reason to carry around the cloth, so"<<
    endl << "you decide against taking it with you." << endl;
  }
  else
    cout << "What are you trying to get?" << endl;
}

void move12(char token2[], char token3[])
{
  if (!strcmp(token2, "tapestry"))
  {
    cout << "You move the tapestry and look behind it, but you don't" <<
    endl << "see anything except a blank wall.  Sorry, but this isn't"<<
    endl << "King's Quest 3, you won't find hidden messages behind" <<
    endl << "the tapestries." << endl;
  }
  else if (!strcmp(token2, "altar") || !strcmp(token3, "altar"))
  {
    cout << "You put your weight and strength behind pushing the altar" <<
    endl << "but nothing happens.  The altar hasn't budged at all." << endl;
  }
  else if (!strcmp(token2, "cloth"))
    cout << "You don't need to move the cloth." << endl;
  else if (!strcmp(token2, "candelabra") || !strcmp(token2, "candelabras"))
    cout << "You will get no use from moving the candelabras." << endl;
  else if (!strcmp(token2, "amulet"))
    cout << "How about just taking it instead?" << endl;
  else
    cout << "";
}
