/* room17.h - Altar room (Mordekai side)
 * Created: 3. August 1999 
 * Last modified: 10. August 1999
 */

#include <iostream.h>
#include <stdlib.h> // necessary for exit(1)
#include <stdio.h>

void init17(char string[]);
void desc17();
void look17(Room [], char [], char [], char []);
void cast17(Myr &, char [], char []);
void place17(Myr &, Room [], char [], char [], char []);
void give17(Myr &, Room [], char[], char []);

void room17(Myr & wytch, Room rooms[], int & setroom)
{
  char command[44], token[10], token2[10], token3[10], token4[10];
  char breakloop[4] = "";


  desc17();

  do
  {

    printf("\n> ");

    /* initialize the tokens */
    init(token);
    init(token2);
    init(token3);
    init(token4);

    gets(command);
    sscanf(command, "%s %s %s %s", token, token2, token3, token4);

    /* Scan the command for any useless words */
    scanprep(token, token2, token3, token4);

    if (!strcmp(token, "exit") && !strcmp(token2, "game"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "quit"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "help"))
      help();
    else if (!strcmp(token, "tutorial"))
      tutorial();
    else if (!strcmp(command, "save") || !strcmp(command, "save game"))
      savegame(setroom, wytch, rooms);
    else if (!strcmp(command, "restore") || !strcmp(command, "restore game"))
      restoregame(setroom, wytch, rooms, breakloop);
    else if (!strcmp(token, "i") || !strcmp(token, "inventory"))
      wytch.printInv();
    else if (!strcmp(token, "stats"))
      wytch.stats();
    else if (!strcmp(token, "e") || !strcmp(token, "east"))
    {
      cout << "You walk back to the center of the altar room." << endl;
      rooms[16].setPrevRoom(17);
      setroom = 16;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "w") || !strcmp(token, "west"))
      cout << "You can't go in that direction." << endl;
    else if (!strcmp(token, "n") || !strcmp(token, "north"))
      cout << "You can't go in that direction." << endl;
    else if (!strcmp(token, "s") || !strcmp(token, "south"))
      cout << "You can't go in that direction." << endl;
    else if ((!strcmp(token, "fuck")) || (!strcmp(token, "shit")))
    {
      cout << "Well, if that's the way you're going to be..." << endl;
      exit(1);
    }
    else if (!strcmp(token, "asshole"))
    {
      cout << "This game doesn't tolerate such foul language." << endl;
      exit(1);
    }
    else if (!strcmp(token, "look"))
    {
      look17(rooms, token2, token3, token4);
    }
    else if (!strcmp(token, "cast"))
    {
      cast17(wytch, token2, token3);
    }
    else if (!strcmp(token, "get") || !strcmp(token, "take"))
    {
      if (!strcmp(token2, "amulet") && (rooms[17].searchItem("amulet") != 0))
	cout << "You don't need to take the amulet back." << endl;
      else
	cout << "There is nothing here which you can take." << endl;
    }
    else if (!strcmp(token, "put") || !strcmp(token, "place"))
      place17(wytch, rooms, token2, token3, token4);
    else if (!strcmp(token, "give"))
      give17(wytch, rooms, token2, token3);
    else if (!strcmp(token, "sacrifice") && !strcmp(token2, "self"))
    {
      cout << "While the Dark Immortal Mordekai might delight in you sacrificing"<<
      endl << "yourself to Him, that would NOT be the appropriate action in "<<
      endl << "winning this game.  Let's say you did, but really didn't and "<<
      endl << "continue adventuring instead..." << endl;
    }
    else if (!strcmp(token, "drink"))
      drink(wytch, token2, token3, 4); // 4 is just a general number for now
    else if (!strcmp(token, "drop"))
    {
      wytch.removeInv(token2);
      rooms[17].insertItem(token2, 1);
    }

    else
      cout << "";
  }
  while(strcmp(breakloop, "bye") != 0);
}

/*********************************************************
 * init17(char string[])                                *
 * initialize the tokens to clear them out               *
 ********************************************************/
void init17(char string[])
{
  for (int i = 0; i < 10; i++)
    string[i] = '\0';
}


/*********************************************************
 * desc17()                                             *
 * Gives the room description                            *
 ********************************************************/
void desc17()
{
  cout << 
  endl << "You are at the dark end of the altar room.  There is a mushroom" <<
  endl << "shaped altar here." << endl;
}


/*********************************************************
 * look17()                                             *
 ********************************************************/
void look17(Room rooms[], char token2[], char token3[], char token4[])
{
  if (!strcmp(token2, "altar") || !strcmp(token3, "altar"))
  {
    cout << "This altar of Mordekai resembles a large stone mushroom" <<
    endl << "growing out of the floor.  There is a small offering bowl"<<
    endl << "carved into the top of the altar.  ";
    if (rooms[17].searchItem("amulet") !=0)
    {
      cout << "Your gift of an amulet is " << 
      endl << "resting in the offering bowl." << endl;
    }
    else
    {
      cout << "The offering bowl is empty, " <<
      endl << "and almost begs to you for a gift." << endl;
    }
  }
  else if (!strcmp(token2, "room") || !strcmp(token2, ""))
    desc17();
  else
    cout << "";
}


/*********************************************************
 * cast17()                                             *
 ********************************************************/
void cast17(Myr & wytch, char token2[], char token3[])
{
  int casted = 0; // initially the spell has not been cast yet

  // concatenate token2 & token 3
  if (strcmp(token3, "\0")) // if token is not NULL
  {
    strcat(token2, " ");
    strcat(token2, token3);
  }

  wytch.castSpell(token2, casted);

  if (casted == 1)
  {
    if (!strcmp(token2, "Sense") || !strcmp(token2, "History"))
    {
      cout << "The amount of Evil you sense over at this end nearly makes"<<
      endl << "you nauseous to even stand over here." << endl;
    }
    else if (!strcmp(token2, "Translate"))
    {
      cout << "You now have the ability to translate similar languages to"<<
      endl << "ones you already know." << endl;
    }
    else if (!strcmp(token2, "Psychic Block"))
      cout << "You prepare yourself from psychic attacks." << endl;
    else
    {
      cout << "While practicing was fun, your spell has no immediate use"<<
      endl << "here right now." << endl;
    }
  }
}

void place17(Myr & wytch, Room rooms[], char token2[], char token3[], char token4[])
{
  if (!strcmp(token2, "amulet"))
  {
    if (wytch.searchInv("amulet") != 0)
    {
      if (!strcmp(token3, "altar") || !strcmp(token4, "altar"))
      {
        cout << "You place the amulet on the altar.  The altar nearly seems" <<
        endl << "to glow with your gift." << endl;;
	rooms[16].setMiscvar(0, 1); // the dark altar portion is finished
	wytch.removeInv("amulet");
	rooms[17].insertItem("amulet", 1);
	if (rooms[16].getMiscvar(0) == 1 && rooms[16].getMiscvar(1) ==1)
	{
	  cout <<
	  endl << "You then notice a light behind you.  As you turn, you " <<
	  endl << "see a column of light rising up from the symbol on the" <<
	  endl << "floor.  A crazed-looking man stands in the center of " <<
	  endl << "the column of light." << endl;
	}
      }
      else if (!strcmp(token3, "bowl") || !strcmp(token4, "bowl"))
      {
        cout << "You place the amulet on the altar.  The altar nearly seems" <<
        endl << "to glow with your gift." << endl;
	rooms[16].setMiscvar(0, 1); // the dark altar portion is finished
	wytch.removeInv("amulet");
	rooms[17].insertItem("amulet", 1);
	if (rooms[16].getMiscvar(0) == 1 && rooms[16].getMiscvar(1) ==1)
	{
	  cout <<
	  endl << "You then notice a light behind you.  As you turn, you " <<
	  endl << "see a column of light rising up from the symbol on the" <<
	  endl << "floor.  A crazed-looking man stands in the center of " <<
	  endl << "the column of light." << endl;
	}
      }
      else if (!strcmp(token3, "\0"))
	cout << "Where do you want to put the amulet?" << endl;
      else
	cout << "You shouldn't put the amulet there." << endl;
    }
    else
      cout << "You don't have an amulet to use." << endl;
  }
  else if (!strcmp(token3, "altar") || !strcmp(token4, "altar"))
  {
    cout << "You try and put the " << token2 << " on the altar, but nothing"<<
    endl << "seems to happen so you take your " << token2 << " back." << endl;
  }
  else
    cout << "You can't use the " << token2 << " here." << endl;
}

void give17(Myr & wytch, Room rooms[], char token2[], char token3[])
{
  if (!strcmp(token2, "amulet"))
  {
    if (wytch.searchInv("amulet") != 0)
    {
      cout << "You place the amulet on the altar.  The altar nearly seems" <<
      endl << "to glow with your gift." << endl;
      rooms[16].setMiscvar(0, 1); // the dark altar portion is finished
      wytch.removeInv("amulet");
      rooms[17].insertItem("amulet", 1);
	if (rooms[16].getMiscvar(0) == 1 && rooms[16].getMiscvar(1) ==1)
	{
	  cout <<
	  endl << "You then notice a light behind you.  As you turn, you " <<
	  endl << "see a column of light rising up from the symbol on the" <<
	  endl << "floor.  A crazed-looking man stands in the center of " <<
	  endl << "the column of light." << endl;
	}
    }
    else
      cout << "You don't have an amulet to give." << endl;
  }
  else
  {
    cout << "You try and put the " << token2 << " on the altar, but nothing"<<
    endl << "seems to happen so you take your " << token2 << " back." << endl;  
  }
  
}
