/* room19.h - Beach - edge of island
 * File created: 10. June 1999 
 * Last modified: 23. June 1999
 */

#include <iostream.h>
#include <stdlib.h> // necessary for exit(1)

void init19(char string[]);
void desc19();

void room19(Myr & wytch, Room rooms[], int & setroom)
{
  char command[25], token[10], token2[10], token3[10], token4[10];
  char breakloop[4] = "";

  desc19();

  do
  {

    // printf("\n> ");

    /* initialize the tokens */
    init19(token);
    init19(token2);
    init19(token3);
    init19(token4);

    //gets(command);
    //sscanf(command, "%s %s %s %s", token, token2, token3, token4);

    strcpy(command, "quit game"); // this is temporary, just for demo

    if (!strcmp(command, "exit game") || !strcmp(command, "quit game"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "quit"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "stats"))
      wytch.stats();
    else if (!strcmp(token, "i") || !strcmp(token, "inventory"))
      wytch.printInv();
    else if (!strcmp(command, "help"))
      help();
    else if (!strcmp(command, "tutorial"))
      tutorial();
    else if (!strcmp(command, "save") || !strcmp(command, "save game"))
      savegame(setroom, wytch, rooms);
    else if (!strcmp(command, "restore") || !strcmp(command, "restore game"))
      restoregame(setroom, wytch, rooms, breakloop);
    else
      cout << "";
  }
  while(strcmp(breakloop, "bye") != 0);
}

/*********************************************************
 * init19(char string[])                                 *
 * initialize the tokens to clear them out               *
 ********************************************************/
void init19(char string[])
{
  for (int i = 0; i < 10; i++)
    string[i] = '\0';
}

void desc19()
{
  cout <<
  endl << "You have reached the edge of the small island.  A small " <<
  endl << "sandy coast snuggles up against the river, providing as " <<
  endl << "a barrier between the trees and the cold biting waters." <<
  endl << 
  endl << "You untie your boat from the tree laying haphazardly on " <<
  endl << "the beach, and get in it.  You row off the coast and to " <<
  endl << "whatever new pez-filled adventure might await you." <<
  endl <<
  endl << "CONGRATULATIONS!  You have beaten the demo version of "<<
  endl << "Psychomancer.  Hope you enjoyed playing the game." <<
  endl << endl;
}
