/* room6.h - Apothecary
 * Created: 4. August 1999 
 * Last modified: 13. August 1999
 */

#include <iostream.h>
#include <stdlib.h> // necessary for exit(1)
#include <stdio.h>

void init6(char string[]);
void desc6();
void look6(Myr, Room [], char [], char [], char []);
void cast6(Myr &, Room [], char [], char []);
void take6(Myr &, Room [], char [], char []);
void open6(Myr &, Room [], char [], char []);
void heat6(Myr &, Room [], char [], char [], int);

void room6(Myr & wytch, Room rooms[], int & setroom)
{
  char command[44], token[10], token2[10], token3[10], token4[10];
  char breakloop[4] = "";
  int brazier = 0; // brazier is not lit when room is entered

  desc6();

  do
  {

    printf("\n> ");

    /* initialize the tokens */
    init(token);
    init(token2);
    init(token3);
    init(token4);

    gets(command);
    sscanf(command, "%s %s %s %s", token, token2, token3, token4);

    /* Scan the command for any useless words */
    scanprep(token, token2, token3, token4);

    if (!strcmp(token, "exit") && !strcmp(token2, "game"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "quit"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "help"))
      help();
    else if (!strcmp(token, "tutorial"))
      tutorial();
    else if (!strcmp(command, "save") || !strcmp(command, "save game"))
      savegame(setroom, wytch, rooms);
    else if (!strcmp(command, "restore") || !strcmp(command, "restore game"))
      restoregame(setroom, wytch, rooms, breakloop);
    else if (!strcmp(token, "i") || !strcmp(token, "inventory"))
      wytch.printInv();
    else if (!strcmp(token, "stats"))
      wytch.stats();
    else if (!strcmp(token, "e") || !strcmp(token, "east"))
    {
      cout << "You leave the apothecary." << endl;
      rooms[4].setPrevRoom(6);
      setroom = 4;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "n") || !strcmp(token, "north"))
      cout << "You can't go in that direction." << endl;
    else if (!strcmp(token, "s") || !strcmp(token, "south"))
      cout << "You can't go in that direction." << endl;
    else if (!strcmp(token, "w") || !strcmp(token, "west"))
      cout << "You can't go in that direction." << endl;
    else if ((!strcmp(token, "fuck")) || (!strcmp(token, "shit")))
    {
      cout << "Well, if that's the way you're going to be..." << endl;
      exit(1);
    }
    else if (!strcmp(token, "asshole"))
    {
      cout << "This game doesn't tolerate such foul language." << endl;
      exit(1);
    }
    else if (!strcmp(token, "look"))
      look6(wytch, rooms, token2, token3, token4);
    else if (!strcmp(token, "cast"))
      cast6(wytch, rooms, token2, token3);
    else if (!strcmp(token, "get") || !strcmp(token, "take"))
      take6(wytch, rooms, token2, token3);
    else if (!strcmp(token, "open") || !strcmp(token, "unlock"))
      open6(wytch, rooms, token2, token3);
    else if (!strcmp(token, "heat") || !strcmp(token, "boil"))
      heat6(wytch, rooms, token2, token3, brazier);
    else if (!strcmp(token, "light") && !strcmp(token2, "brazier"))
    {
      if (wytch.searchInv("tinderbox") != 0)
      {
	cout << "Using your tinderbox, you light the brazier." << endl;
	brazier = 1; // brazier is now lit.
      }
      else if (wytch.retCircle() == 2)
      {
        cout << "Expending a small portion of your Essence, you light the" <<
        endl << "the brazier." << endl;
	wytch.modEssence(-1);
        brazier = 1; // brazier is now lit.
      }
      else
	cout << "You have no way to light the brazier right now." << endl;
    }
    else if (!strcmp(token, "drink"))
      drink(wytch, token2, token3, 4); // 4 is just a general number for now
    else if (!strcmp(token, "drop"))
    {
      wytch.removeInv(token2);
      rooms[6].insertItem(token2, 1);
    }

    else
      cout << "";
  }
  while(strcmp(breakloop, "bye") != 0);
}

/*********************************************************
 * init6(char string[])                                *
 * initialize the tokens to clear them out               *
 ********************************************************/
void init6(char string[])
{
  for (int i = 0; i < 10; i++)
    string[i] = '\0';
}


/*********************************************************
 * desc6()                                             *
 * Gives the room description                            *
 ********************************************************/
void desc6()
{
  cout << 
  endl << "A wave of dust and other odors from chemicals assault your senses"<<
  endl << "as you enter the apothecary.  The room is cramped with the "<<
  endl << "various tables and shelves and other items scattered on them."<<
  endl << "Behind the center table is a chest tucked away into the corner of"<<
  endl << "the room." << endl;
}


/*********************************************************
 * look6()                                             *
 ********************************************************/
void look6(Myr wytch, Room rooms[], char token2[], char token3[], char token4[])
{
  if (!strcmp(token2, "table"))
  {
    if (rooms[6].searchItem("scroll") != 0)
    {
      cout << "The table is cluttered with many items such as a brazier, a"<<
      endl << "mortar and pestal, a scroll, flasks (mostly cracked), and a "<<
      endl << "dusty book.  You inspect the book, but cannot read its "<<
      endl << "contents." << endl;
    }
    else
    {
      cout << "The table is cluttered with many items such as a brazier, a"<<
      endl << "mortar and pestal, several cracked flasks, and a dusty "<<
      endl << "book.  You inspect the book, but cannot read its contents."<<
      endl;
    }
  }
  else if (!strcmp(token2, "mortar") || !strcmp(token2, "pestal"))
  {
    cout << "You see a mortar and pestal laying on the table, used for" <<
    endl << "grinding up objects." << endl;
  }
  else if (!strcmp(token2, "chest"))
    cout << "A metal-bound chest sits in the corner of the room." << endl;
  else if (!strcmp(token2, "flask") || !strcmp(token2, "flasks"))
  {
    cout << "You scrounge through the flasks, but most of them are " <<
    endl << "or broken. ";

    if (rooms[6].searchItem("empty flask") != 0)
    {
      cout << "You do happen to find a single remaining flask " <<
      endl << "which isn't cracked or broken." << endl;
    }
    else
      cout << endl;

  }
  else if (!strcmp(token2, "brazier"))
  {
    cout << "There is a small, charcoal, metal brazier on the table, used"<<
    endl << "for heating." << endl;
  }
  else if (!strcmp(token2, "book") || !strcmp(token2, "books"))
  {
    cout << "You see several dried out and cracked-looking books around" <<
    endl << "the room, but nothing you find interesting or useful." << endl;
  }
  else if (!strcmp(token2, "shelf") || !strcmp(token2, "shelves"))
  {
    cout << "You see various books (all which are illegible to you) and " <<
    endl << "alchemical devices.  You see several potions on a rack which" <<
    endl << "interest you." << endl;
  }
  else if (!strcmp(token2, "devices") || !strcmp(token3, "devices"))
  {
    cout << "You see various alchemical devices and tools laying on the " <<
    endl << "shelves, none which would help you on your quest." << endl;
  }
  else if (!strcmp(token2, "potion") || !strcmp(token2, "potions"))
  {
    cout << "You see a rack with several different colored potions. You see"<<
    endl << "a blue, red, green, and clear potion." << endl;
  }
    else if (!strcmp(token2, "rack"))
  {
    cout << "You see a rack with several different colored potions. You see"<<
    endl << "a blue, red, green, and clear potion." << endl;
  }
  else if (!strcmp(token2, "blue"))
  {
    cout << "You see a blue potion which swirls a bit." << endl;
  }
  else if (!strcmp(token2, "red"))
  {
    cout << "You see two red potions." << endl;
  }
  else if (!strcmp(token2, "green"))
  {
    cout << "You look at the vial holding the sickly green ichor.  It " <<
    endl << "doesn't look very appetizing." << endl;
  }
  else if (!strcmp(token2, "clear") || !strcmp(token2, "crystal"))
  {
    cout << "The clear potion fizzes and bubbles a bit.  It looks like " <<
    endl << "a relic of some sort." << endl;
  }
  else if (!strcmp(token2, "room") || !strcmp(token2, ""))
    desc6();
  else
    cout << "";
}


/*********************************************************
 * cast6()                                             *
 ********************************************************/
void cast6(Myr & wytch, Room rooms[], char token2[], char token3[])
{
  int casted = 0; // initially the spell has not been cast yet

  // concatenate token2 & token 3
  if (strcmp(token3, "\0")) // if token is not NULL
  {
    strcat(token2, " ");
    strcat(token2, token3);
  }

  wytch.castSpell(token2, casted);

  if (casted == 1)
  {
    if (!strcmp(token2, "Unlock"))
    {
      rooms[6].doFunct(0, "unlockDoor");
      cout << "You cast your Unlock spell and the chest's lock snaps open." <<
      endl;
    }
    else if (!strcmp(token2, "Mental Key"))
    {
      cout << "The chest yields to the strength of your spell and the " <<
      endl << "lock is released." << endl;
      rooms[6].doFunct(0, "unlockDoor");
    }
    else if (!strcmp(token2, "Elixer"))
    {
      if (wytch.searchInv("boiling water") != 0)
      {
	cout << "You cast your spell over the flask of boiling water.  The"<<
	endl << "water settles and turns a slight rose color.  You now have"<<
	endl << "an Elixer which restores eight Life Points when consumed."<<
	endl;
	wytch.removeInv("boiling water");
	wytch.insertInv("elixer", 1);
      }
      else
      {
	cout << "You don't have any boiling water which is necessary to " <<
	endl << "complete the spell." << endl;
      }
    }
    else if (!strcmp(token2, "Sense") || !strcmp(token2, "History"))
    {
      cout << "You sense a great deal of old magic in this room, mostly "<<
      endl << "in the form of alchemical forumlas." << endl;
    }
    else if (!strcmp(token2, "Psychic Block"))
    {
      cout << "You cast the Psychic Block spell.  It will help ward off"<<
      endl << "psychic assaults such as Psychic Blast." << endl;
    }
    else
    {
      cout << "While your spell isn't useful here, you do get in some "<<
      endl << "practice" << endl;
    }
  }
}

void take6(Myr & wytch, Room rooms[], char token2[], char token3[])
{
  if (!strcmp(token2, "flask") || !strcmp(token3, "flask"))
  {
    if (rooms[6].searchItem("empty flask") != 0)
    {
      cout << "You take the empty flask." << endl;
      rooms[6].removeItem("empty flask");
      wytch.insertInv("empty flask", 1);
    }
    else
    {
      cout << "You search through the empty flasks, but they are all cracked"<<
      endl << "and useless." << endl;
    }
  }
  else if (!strcmp(token2, "potion"))
    cout << "Which color of potion do you want to take?" << endl;
  else if (!strcmp(token2, "blue"))
  {
    cout << "You pick up the blue potion." << endl;
    wytch.insertInv("blue potion", 1);
    rooms[6].removeItem("blue potion");
  }
  else if (!strcmp(token2, "red"))
  {
    cout << "You pick up the red potions." << endl;
    wytch.insertInv("red potion", 2);
    rooms[6].removeItem("red potion");
    rooms[6].removeItem("red potion");
  }
  else if (!strcmp(token2, "green"))
  {
    cout << "You pick up the green potion." << endl;
    wytch.insertInv("green potion", 1);
    rooms[6].removeItem("green potion");
  }
  else if (!strcmp(token2, "clear"))
  {
    cout << "You pick up the clear potion." << endl;
    wytch.insertInv("clear potion", 1);
    rooms[6].removeItem("clear potion");
  }
  else if (!strcmp(token2, "chest"))
    cout << "The chest is too large and heavy for you to carry around."<< endl;
  else if (!strcmp(token2, "scroll"))
  {
    if (rooms[6].searchItem("scroll") != 0)
    {
      cout << "You pick up the scroll and read it.  You now know how to " <<
      endl << "cast the Elixer spell." << endl;
      rooms[6].removeItem("scroll");
      wytch.addSpell("Elixer", 6);
    }
  }
  else if (!strcmp(token2, "mortar") || !strcmp(token2, "pestal"))
    cout << "You don't need to take the mortar and pestal." << endl;
  else if (!strcmp(token2, "book") || !strcmp(token2, "books"))
  {
    cout << "You have no need of any of the books in here since you" <<
    endl << "can't understand any of them." << endl;
  }
  else if (!strcmp(token2, "bowl") || !strcmp(token3, "bowl"))
    cout << "You have no need of a mixing bowl right now." << endl;
  else
    cout << "What are you trying to take?" << endl;
}

void open6(Myr & wytch, Room rooms[], char token2[], char token3[])
{
  if (!strcmp(token2, "chest"))
  {
    if (rooms[6].doFunct2(0, "isLocked") == 0)
    {
      if (rooms[6].getMiscvar(0) == 1)
      {
      cout << "You open the chest.  You find some old clothes and other" << 
      endl << "assorted useless items, but you do happen to find a scroll" <<
      endl;
      if (wytch.retCircle() == 1)
      {
	cout << "You eagerly take the scroll and read it.  You now know the"<<
	endl << "Aura spell." << endl;
	wytch.addSpell("Aura", 2);
	rooms[6].setMiscvar(0, 0); // the chest has no scroll now
      }
      else
      {
	cout << "You eagerly take the scroll and read it.  You now know the"<<
	endl << "Psychic Block spell." << endl;
	wytch.addSpell("Psychic Block", 4);
	rooms[6].setMiscvar(0, 0); // the chest has no scroll now
      }
      }
      else
      {
	cout << "You open the chest.  You find some old clothes and other"<<
	endl << "assorted useless items.  You have taken anything of any"<<
	endl << "value already." << endl;
      }
    }
    else
      cout << "The chest is locked and can't be opened right now." << endl;
  }
}

void heat6(Myr & wytch, Room rooms[], char token2[], char token3[], int brazier)
{
  if (!strcmp(token2, "water"))
  {
    if (brazier == 1)
    {
      if (wytch.searchInv("flask of water") != 0)
      {
        cout << "You set the flask of water on the wire stand over the " << 
        endl << "charcoals in the brazier.  After a few minutes the flask"<<
	endl << "begins heat up and the water begins to boil.  You quickly"<<
	endl << "take it before it gets too hot to handle (is that a UFO"<<
	endl << "song I hear playing in the background?)." << endl;
	wytch.removeInv("flask of water");
	wytch.insertInv("boiling water", 1);
      }
      else
	cout << "You don't have any water to boil." << endl;
    }
    else
    {
      cout << "You can't boil anything right now since the brazier isn't" <<
      endl << "lit right now." << endl;
    }
  }
  else
    cout << "You can't boil that." << endl;
}
