/* room7.h 
 * created: 19. June 1999 
 * last modified: 20. June 1999
 */

#include <iostream.h>
#include <stdlib.h> // necessary for exit(1)

void init7(char string[]);
void desc7();
void move7(Myr &);

void room7(Myr & wytch, Room rooms[], int & setroom)
{
  char command[25], token[10], token2[10], token3[10], token4[10];
  char breakloop[4] = "";

  desc7();

  do
  {

    printf("\n> ");

    init7(token);
    init7(token2);
    init7(token3);
    init7(token4);

    gets(command);
    sscanf(command, "%s %s %s %s", token, token2, token3, token4);

    if (!strcmp(command, "exit game") || !strcmp(command, "quit game"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "quit"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(command, "stats"))
      wytch.stats();
    else if (!strcmp(command, "i") || !strcmp(command, "inventory"))
      wytch.printInv();
    else if (!strcmp(command, "help"))
      help();
    else if (!strcmp(command, "tutorial"))
      tutorial();
    else if (!strcmp(command, "save") || !strcmp(command, "save game"))
      savegame(setroom, wytch, rooms);
    else if (!strcmp(command, "restore") || !strcmp(command, "restore game"))
      restoregame(setroom, wytch, rooms, breakloop);
    else if (!strcmp(command, "d") || !strcmp(command, "down"))
    {
      move7(wytch);
      if (rooms[7].retPrevRoom() == 0)
        cout << "You shuffle backwards and return to the prison." << endl;
      else
        cout << "You burrow downwards and enter the prison cell." << endl;
      rooms[0].setPrevRoom(7);
      strcpy(breakloop, "bye");
      setroom = 0;
    }
    else if (!strcmp(command, "u") || !strcmp(command, "up"))
    {
      move7(wytch); // description of moving
      cout << "You struggle up through the tunnel.  The end of the tunnel"
      << endl << "is blocked off by a stone.  Luckily, it moves away with"
      << endl << "minimal effort and you crawl out from the tunnel." <<
      endl;
      strcpy(breakloop, "bye");
      setroom = 18;
      rooms[18].doFunct(0, "setMisc");
    }
    else if (!strcmp(token, "look"))
      desc7();
    else if (!strcmp(token, "drink"))
      drink(wytch, token2, token3, 0);
    else if (!strcmp(token, "cast"))
    {
      cout << "You are not in the position to cast spells right now." <<
      endl;
    }
    else
      cout << "Eh?" << endl;
  }
  while(strcmp(breakloop, "bye") != 0);

}

/*********************************************************
 * init7(char string[])                                  *
 * initialize the tokens to clear them out               *
 ********************************************************/
void init7(char string[])
{
  for (int i = 0; i < 10; i++)
    string[i] = '\0';
}

void desc7()
{
  cout <<
  endl << "You are in a long, narrow, underground tunnel which is " <<
  endl << "barely wide enough for you to fit through.  The tunnel is " <<
  endl << "slightly inclined which forces you to climb up or down through" <<
  endl << "the tunnel." << endl;
}

void move7(Myr & wytch)
{
  cout <<
  endl << "You struggle and squirm your way through the underground " <<
  endl << "passage and result in bruising and cutting up yourself all " <<
  endl << "over your body." << endl << endl;

  if (wytch.retLife() == 1)
  {
    cout << "You have overexerted yourself to the point where you " <<
    endl << "collapse into a lifeless heap, destined to become " <<
    endl << "worm food.  But at least look on the bright side, " <<
    endl << "you are already in the ground and now you won't have " <<
    endl << "to pay for exorbriant burial costs." << endl << endl;
    exit(1);
  }

  wytch.modLife(-1);

}
