/* room8.h 
 * Created: 26. July 1999 
 * Last modified: 9. August 1999
 */

void init8(char string[]);
void desc8();
void look8(Myr &, char [], char [], char []);
void cast8(Myr &, char [], char []);

void room8(Myr & wytch, Room rooms[], int & setroom)
{
  char command[44], token[10], token2[10], token3[10], token4[10];
  char breakloop[4] = "";

  if (rooms[8].retPrevRoom() == 4 && wytch.searchInv("boiling water") != 0)
  {
    cout << "Your boiling water has cooled off." << endl;
    wytch.removeInv("boiling water");
    wytch.insertInv("flask of water", 1);
  }

  desc8();

  do
  {

    printf("\n> ");

    /* initialize the tokens */
    init8(token);
    init8(token2);
    init8(token3);
    init8(token4);

    gets(command);
    sscanf(command, "%s %s %s %s", token, token2, token3, token4);

    /* Scan the command for any useless words */
    scanprep(token, token2, token3, token4);

    if (!strcmp(token, "exit") && !strcmp(token2, "game"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "quit"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "help"))
      help();
    else if (!strcmp(token, "tutorial"))
      tutorial();
    else if (!strcmp(command, "save") || !strcmp(command, "save game"))
      savegame(setroom, wytch, rooms);
    else if (!strcmp(command, "restore") || !strcmp(command, "restore game"))
      restoregame(setroom, wytch, rooms, breakloop);
    else if (!strcmp(token, "i") || !strcmp(token, "inventory"))
    {
      wytch.printInv();
    }
    else if (!strcmp(token, "stats"))
      wytch.stats();
    else if (!strcmp(token, "s") || !strcmp(token, "south"))
    {
      cout << "You ascend the stairs to the dungeon." << endl;
      rooms[9].setPrevRoom(8);
      setroom = 9;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "u") || !strcmp(token, "up"))
    {
      cout << "You ascend the stairs to the first floor of the temple." <<
      endl;
      rooms[9].setPrevRoom(8);
      setroom = 9;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "n") || !strcmp(token, "north"))
    {
      cout << "You open the door and enter the room." << endl;
      rooms[3].setPrevRoom(8);
      setroom = 3;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "e") || !strcmp(token, "east"))
    {
      cout << "You walk down the hallway." << endl << endl;
      rooms[5].setPrevRoom(8);
      setroom = 5;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "w") || !strcmp(token, "west"))
    {
      cout << "You walk down the hallway to the west." << endl << endl;
      rooms[4].setPrevRoom(8);
      setroom = 4;
      strcpy(breakloop, "bye");
    }
    else if ((!strcmp(token, "fuck")) || (!strcmp(token, "shit")))
    {
      cout << "Well, if that's the way you're going to be..." << endl;
      exit(1);
    }
    else if (!strcmp(token, "asshole"))
    {
      cout << "This game doesn't tolerate such foul language." << endl;
      exit(1);
    }
    else if (!strcmp(token, "look"))
    {
      look8(wytch, token2, token3, token4);
    }
    else if (!strcmp(token, "cast"))
    {
      cast8(wytch, token2, token3);
    }
    else if (!strcmp(token, "read"))
    {
      if (!strcmp(token2, "sign"))
      {
       if (wytch.retSpellState("Translate") == 0)
       {
         cout << "The sign is written in a strange script which is "<<
         endl << "unfamiliar to you.  You stare at the sign awhile longer"<<
         endl << "but you cannot discern what it says." << endl;
       }
       else
       {
         cout << "With the aid of your Translate spell, you are able to"<<
         endl << "read the sign.  It says 'LIBRARY'." << endl;
       }
      }
    }
    else if (!strcmp(token, "drink"))
      drink(wytch, token2, token3, 0);
    else if (!strcmp(token, "drop"))
    {
      wytch.removeInv(token2);
      rooms[8].insertItem(token2, 1);
    }
    else
      cout << "";
  }
  while(strcmp(breakloop, "bye") != 0);
}

/*********************************************************
 * init8(char string[])                                *
 * initialize the tokens to clear them out               *
 ********************************************************/
void init8(char string[])
{
  for (int i = 0; i < 10; i++)
    string[i] = '\0';
}


/*********************************************************
 * desc8()                                               *
 * Gives the room description                            *
 ********************************************************/
void desc8()
{
  cout <<
  endl << "You are standing in a corridor running east to west at the" <<
  endl << "bottom of a flight of stairs which lead up to the first floor." <<
  endl << "To the north is a door with a sign over it." << endl;
}


/*********************************************************
 * look8()                                             *
 ********************************************************/
void look8(Myr & wytch, char token2[], char token3[], char token4[])
{
  if (!strcmp(token2, "sign"))
    if (wytch.retSpellState("Translate") == 0)
    {
    cout << "The sign is written in a strange script which is "<<
    endl << "unfamiliar to you.  You stare at the sign awhile longer" <<
    endl << "but you cannot discern what it says." << endl;
    }
    else
    {
      cout << "With the aid of your Translate spell, you are able to " <<
      endl << "read the sign.  It says 'LIBRARY'." << endl;
    }
  else if (!strcmp(token2, "corridor") || !strcmp(token2, "hall"))
  {
    cout << "It is a fairly ordinary and dull, stone corridor running" <<
    endl << "in an east to west direction." << endl;
  }
  else if (!strcmp(token2, "door") || !strcmp(token2, "doors"))
  {
    cout << "It is a wooden door which look nothing out of the "<<
    endl << "ordinary.  You test the handle and find the doors" <<
    endl << "to be unlocked." << endl;
  }
  else if (!strcmp(token2, "room"))
    desc8();
  else
    desc8();
}


/*********************************************************
 * cast8()                                               *
 ********************************************************/
void cast8(Myr & wytch, char token2[], char token3[])
{
  int casted = 0; // initially the spell has not been cast yet

  // concatenate token2 & token 3
  if (strcmp(token3, "\0"))
  {
    strcat(token2, " ");
    strcat(token2, token3);
  }

  wytch.castSpell(token2, casted); // check to see if spell is valid

  if (casted == 1)
  {
    if (!strcmp(token2, "Translate"))
    {
      cout << "You cast the Translate spell.  You now have the "<<
      endl << "ability to read strange and foreign languages." <<
      endl;
    }
    else if (!strcmp(token2, "Sense") || !strcmp(token2, "History"))
    {
      cout << "You sense nothing inherently strange about this place." << 
      endl;
    }
    else
    {
      cout << "While there is no use for your spell here, you do "<<
      endl << "get in some practice." << endl;
    }
  }
}
