class Door
{
public:
  // member functions
  void setDoor(int, int, int, int); // initialize door;
  int  isLocked();
  void lockDoor();
  void unlockDoor();
  int  isClosed();
  void openDoor();
  void closeDoor();
  void setnextRoom(int);
  int  nextRoom();
  int getMisc();
  void setMisc(int);
  void haveFun(void (*)());
  int haveFun2(int (*)());

private:
  // private variables
  int is_locked;
  int is_closed;
  int next_room; // shows which room number the door leads to
  int misc; // miscellaneous variable for whatever
};

void Door :: setDoor(int locked, int closed, int next, int whatever)
{
  is_locked = locked;
  is_closed = closed;
  next_room = next;
  misc = whatever;
}

int Door :: isLocked()
{
  return is_locked;  // return 1 if the door is locked
		     // return 0 if the door is unlocked
}

void Door :: lockDoor()
{
  is_locked = 1;
}

void Door :: unlockDoor()
{
  is_locked = 0;
}

int Door :: isClosed()
{
  return is_closed;  // return 1 if door is closed
		   // return 0 if door is open
}

void Door :: openDoor()
{
  is_closed = 0;
}

void Door :: closeDoor()
{
  is_closed = 1;
}

void Door :: setnextRoom(int roomnum)
{
  next_room = roomnum;
}

int Door :: nextRoom()
{
  return next_room;
}

int Door :: getMisc()
{
  return misc;
}

void Door :: setMisc(int num)
{
  misc = num;
}

void Door :: haveFun(void (*fun)())
{
  fun();
}

int Door :: haveFun2(int (*fun)())
{
  return ((*fun)());
}
