class Node
{
public:
  // member functions
  Node(char [], int);  // constructor
  ~Node(); // destructor

  char * retItemName();
  Node * retNext();
  void setNext(Node *);
  void setNumItem(int);
  int  retNumItem();

private:
  char item_name[20]; // name of item
  int  numitem; // amount of the item carried
  Node *next; // points to next node in list
};

Node :: Node(char name[], int num)
{
  strcpy(item_name, name);
  numitem = num;
  next = NULL;
}

Node :: ~Node()
{}

char *  Node :: retItemName()
{
  return item_name;
}

Node * Node :: retNext()
{
  return next;
}

void Node :: setNext(Node *newnode)
{
  next = newnode;
}

void Node :: setNumItem(int num)
{
  numitem = numitem + num;
}

int Node :: retNumItem()
{
  return (numitem);
}
