/* Parser for rpg2
   Written 10. February 1999
*/

#include <stdio.h>
#include <stdlib.h>
#include "spells.h"

void look(Myr &, char *);
void talk(char *, char *);
void open(char *, char *);
void init(char string[]);

void parser(Myr & wytch, int & setroom)
{
  char command[25], token[10], token2[10], token3[10], token4[10];
  int i;

  do
  {

  printf("\n> ");

  /* initialize the tokens */
  init(token);
  init(token2);
  init(token3);
  init(token4);

  gets(command);
  sscanf(command, "%s %s %s %s", token, token2, token3, token4);

  if (!strcmp(command, "exit game") || !strcmp(command, "quit game"))
    strcpy(token, "quit");

  if (strcmp(token, "look") == 0)
    look(wytch, token2);
  else if (!strcmp(token, "stats"))
    wytch.stats();
  else if (strcmp(token, "open") == 0)
    open(token2, token3);
  else if (!strcmp(token, "cast"))
    spells(wytch, wytch.retCircle(), token2, token3);
  else if ((!strcmp(token, "get")) || (!strcmp(token, "take")))
    wytch.addstuff(token2, 3, 1);
  else if (!strcmp(token, "drop"))
    wytch.drop(token2);
  else if (strcmp(token, "eat") == 0)
    printf("You eat the %s\n", token2);
  else if (strcmp(token, "kill") == 0)
  {
    if (!strcmp(token2, "guard"))
    {
      printf("It would be a lot easier to kill the guard if there\n");
      printf("was one here.\n");
    }
    else if (!strcmp(token2, "prisoner"))
    {
      printf("Um....you DO realize that the prisoner is already \n");
      printf("dead, don't you?  It's pretty silly to try and kill \n");
      printf("something that is already dead.\n");
    }
    else if (!strcmp(token2, "self"))
    {
      cout << "So, the pressure is getting to you, is it?  Well," << endl
           << "don't worry since a 16 ton weight dropped on you," << endl
           << "meting out your timely demise." << endl;
      setroom = 110;
      strcpy(token, "quit");
    }
    else
      printf("You kill the %s\n", token2);
  }
  else if (strcmp(token, "talk") == 0)
    talk(token2, token3);
  else if (!strcmp(token, "inventory") || !strcmp(token, "i"))
    wytch.inventory();
  else if ((!strcmp(token, "fuck")) || (!strcmp(token, "shit")))
  {
    printf("Well, if that's the way you're going to be...\n");
    exit(1);
  }
  else if (!strcmp(token, "quit"))
  {
    setroom = 100;
    printf("Good-bye, thanks for playing.\n\n");
  }
  else
    printf("That did not make sense.\n");
  }
  while(strcmp(token, "quit") != 0);

}

void look(Myr & wytch, char * object)
{
  if (strcmp(object, "prisoner") == 0)
  {
    printf("The former prisoner had been subjected to rot and the \n");
    printf("rats, and not much remains except for the yellowed bones.\n");
  }
  else if (strcmp(object, "rats") == 0)
  {
    printf("While you do not see any rats here, you can hear them \n");
    printf("scurying inside the clammy walls.\n");
  }
  else if (strcmp(object, "door") == 0)
  {
    printf("The door has a small barred window which lets in a \n");
    printf("minimal amount of light.\n");
  }
  else if (!strcmp(object, "floor") && wytch.retLights() == 1)
    printf("On the filthy floor you see a hand-sized stone.\n");
  else if (!strcmp(object, "ground") && wytch.retLights() == 1)
    printf("On the filthy floor you see a hand-sized stone.\n");
  else if (!strcmp(object, "room"))
    printf("You are in a dark, cramped prison cell.\n");
  else if (!strcmp(object, ""))
    printf("You are in a dim cell.  And it smells, too.\n");
  else
    printf("It's hard to do much of anything in the dark.\n");
}

void talk(char * token2, char * token3)
{
  if (strcmp(token2, "prisoner") == 0)
  {
    printf("You talk to the prisoner but don't get much of a response.");
    printf("\nDead people don't talk too often, you should know.\n");
  }
  else if (strcmp(token2, "guard") == 0)
    printf("Despite your cries, there is no guard to hear you.\n");
  else if (strcmp(token2, "to") == 0 && strcmp(token3, "prisoner") == 0)
  {
    printf("You have a meaningful dialog with the remains of the ex-\n");
    printf("prisoner, unfortunately the bones don't have much to add.\n");
  }
  else if (strcmp(token2, "with") == 0 && strcmp(token3, "prisoner") ==0)
  {
    printf("You talk and talk and talk, but the ex-prisoner has\n");
    printf("nothing to say.  Perhaps the prisoner had been one of\n");
    printf("those strong silent types while alive.\n");
  }
  else if (!strcmp(token2, "to") && !strcmp(token3, "self"))
    printf("You talk to yourself.  Fun, isn't it?\n");
  else
  {
    printf("As much as you talk with the %s, you don't receive \n", token2);
    printf("much of an answer.  Perhaps if you tried talking to \n");
    printf("someone, or at least something, which will talk back.\n");
  }  
}

void open(char * token2, char * token3)
{
  if (strcmp(token2, "the") == 0)
  {
    if (!strcmp(token3, "door"))
    {
      printf("That is a good idea, unfortunately your efforts are \n");
      printf("in vain since no effort you make opens the door.\n");
    }
  }
  else if (!strcmp(token2, "door"))
  {
    printf("That is a good idea, unfortunately your efforts are \n");
    printf("in vain since no effort you make opens the door.\n");
  }
  else
    printf("Say what?\n");
}

void init(char string[])
{
  for (int i = 0; i < 10; i++)
    string[i] = '\0';
}
