/* room10.h Hallway (east 1st floor)
 * Created: 1. August 1999 
 * Last modified: 12. August 1999
 */

#include <iostream.h>
#include <stdlib.h> // necessary for exit(1)
#include <stdio.h>

void init10(char string[]);
void desc10();
void look10(char [], char [], char []);
void cast10(Myr &, char [], char []);

void room10(Myr & wytch, Room rooms[], int & setroom)
{
  char command[44], token[10], token2[10], token3[10], token4[10];
  char breakloop[4] = "";


  desc10();

  do
  {

    printf("\n> ");

    /* initialize the tokens */
    init(token);
    init(token2);
    init(token3);
    init(token4);

    gets(command);
    sscanf(command, "%s %s %s %s", token, token2, token3, token4);

    /* Scan the command for any useless words */
    scanprep(token, token2, token3, token4);

    if (!strcmp(token, "exit") && !strcmp(token2, "game"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "quit"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "help"))
      help();
    else if (!strcmp(token, "tutorial"))
      tutorial();
    else if (!strcmp(command, "save") || !strcmp(command, "save game"))
      savegame(setroom, wytch, rooms);
    else if (!strcmp(command, "restore") || !strcmp(command, "restore game"))
      restoregame(setroom, wytch, rooms, breakloop);
    else if (!strcmp(token, "i") || !strcmp(token, "inventory"))
      wytch.printInv();
    else if (!strcmp(token, "stats"))
      wytch.stats();
    else if (!strcmp(token, "n") || !strcmp(token, "north"))
    {
      rooms[14].setPrevRoom(10);
      setroom = 14;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "s") || !strcmp(token, "south"))
    {
      rooms[9].setPrevRoom(10);
      setroom = 9;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "w") || !strcmp(token, "west"))
    {
      cout << "You push aside the curtain and slip inside the alcove." << endl;
      rooms[12].setPrevRoom(10);
      setroom = 12;
      strcpy(breakloop, "bye");
       
    }
    else if (!strcmp(token, "go") && (!strcmp(token2, "door") || !strcmp(token2, "doorway")))
    {
      cout << "You push aside the curtain and slip inside the alcove." << endl;
      rooms[12].setPrevRoom(10);
      setroom = 12;
      strcpy(breakloop, "bye");
       
    }
    else if (!strcmp(token, "e") || !strcmp(token, "east"))
      cout << "You can't go in that direction." << endl;
    else if (!strcmp(token, "u") || !strcmp(token, "up"))
    {
      cout << "Who do you think you are?  Superman?  The only way" << 
      endl << "you'll be able to go up is to cast the Flying spell"<< 
      endl << "and that isn't offered in this game.  Sorry, you're"<<
      endl << "out of luck." << endl;
    }
    else if ((!strcmp(token, "fuck")) || (!strcmp(token, "shit")))
    {
      cout << "Well, if that's the way you're going to be..." << endl;
      exit(1);
    }
    else if (!strcmp(token, "asshole"))
    {
      cout << "This game doesn't tolerate such foul language." << endl;
      exit(1);
    }
    else if (!strcmp(token, "look"))
    {
      look10(token2, token3, token4);
    }
    else if (!strcmp(token, "cast"))
    {
      cast10(wytch, token2, token3);
    }
    else if (!strcmp(token, "move") && !strcmp(token2, "curtain"))
    {
      cout << "You move the curtain and take a look behind it to see " <<
      endl << "an altar in a small prayer room." << endl;
    }
    else if (!strcmp(token, "drop"))
    {
      wytch.removeInv(token2);
      rooms[10].insertItem(token2, 1);
    }

    else
      cout << "";
  }
  while(strcmp(breakloop, "bye") != 0);
}

/*********************************************************
 * init10(char string[])                                *
 * initialize the tokens to clear them out               *
 ********************************************************/
void init10(char string[])
{
  for (int i = 0; i < 10; i++)
    string[i] = '\0';
}


/*********************************************************
 * desc10()                                             *
 * Gives the room description                            *
 ********************************************************/
void desc10()
{
  cout << 
  endl << "Your footsteps make a flat echo in this short corridor."<<
  endl << "To both your north and south the hallway runs perpendicular"<<
  endl << "to other halls.  There is a doorway covered with a curtain"<<
  endl << "off to the west." << endl;
}


/*********************************************************
 * look10()                                             *
 ********************************************************/
void look10(char token2[], char token3[], char token4[])
{
  if (!strcmp(token2, "curtain"))
    cout << "You see a heavy curtain covering the doorway." << endl;
  else if (!strcmp(token2, "hall") || !strcmp(token2, "room"))
    desc10();
  else
    desc10();
}


/*********************************************************
 * cast10()                                             *
 ********************************************************/
void cast10(Myr & wytch, char token2[], char token3[])
{
  int casted = 0; // initially the spell has not been cast yet

  // concatenate token2 & token 3
  if (strcmp(token3, "\0")) // if token is not NULL
  {
    strcat(token2, " ");
    strcat(token2, token3);
  }

  wytch.castSpell(token2, casted);

  if (casted == 1)
  {
  }
}
