/* room4.h 
 * Created: 23. July 1999 
 * Last modified: 9. August 1999
 * Hallway on 2nd level which connects to the apothecary
 */

#include <iostream.h>
#include <stdlib.h> // necessary for exit(1)
#include <stdio.h>

void init4(char string[]);
void desc4();
void look4(Myr, char [], char [], char []);
void open4(char [], Room []);
void cast4(Myr &, char [], char []);

void room4(Myr & wytch, Room rooms[], int & setroom)
{
  char command[44], token[10], token2[10], token3[10], token4[10];
  char breakloop[4] = "";

  desc4();

  do
  {

    printf("\n> ");

    /* initialize the tokens */
    init4(token);
    init4(token2);
    init4(token3);
    init4(token4);

    gets(command);
    sscanf(command, "%s %s %s %s", token, token2, token3, token4);

    /* Scan the command for any useless words */
    scanprep(token, token2, token3, token4);

    if (!strcmp(token, "exit") && !strcmp(token2, "game"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "quit"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "help"))
      help();
    else if (!strcmp(token, "tutorial"))
      tutorial();
    else if (!strcmp(command, "save") || !strcmp(command, "save game"))
      savegame(setroom, wytch, rooms);
    else if (!strcmp(command, "restore") || !strcmp(command, "restore game"))
      restoregame(setroom, wytch, rooms, breakloop);
    else if (!strcmp(token, "i") || !strcmp(token, "inventory"))
      wytch.printInv();
    else if (!strcmp(token, "stats"))
      wytch.stats();
    else if (!strcmp(token, "n") || !strcmp(token, "north"))
    {
      rooms[2].setPrevRoom(4);
      setroom = 2;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "s") || !strcmp(token, "south"))
    {
      cout << "You walk further down the hall." << endl;
      rooms[8].setPrevRoom(4);
      setroom = 8;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "w") || !strcmp(token, "west"))
    {
      if (rooms[4].doFunct2(0, "isClosed") == 0)
      {
        cout << "You walk into the room." << endl;
        rooms[6].setPrevRoom(4);
        setroom = 6;
        strcpy(breakloop, "bye");
      }
      else
        cout << "The door is closed and locked." << endl;
    }
    else if ((!strcmp(token, "fuck")) || (!strcmp(token, "shit")))
    {
      cout << "Well, if that's the way you're going to be..." << endl;
      exit(1);
    }
    else if (!strcmp(token, "asshole"))
    {
      cout << "This game doesn't tolerate such foul language." << endl;
      exit(1);
    }
    else if (!strcmp(token, "look"))
    {
      look4(wytch, token2, token3, token4);
    }
    else if (!strcmp(token, "cast"))
    {
      cast4(wytch, token2, token3);
    }
    else if (!strcmp(token, "open") || !strcmp(token, "unlock"))
      open4(token2, rooms);
    else if (!strcmp(token, "read") && !strcmp(token2, "sign"))
    {
      if (wytch.retSpellState("Translate") == 0)
      {
        cout << "The sign is written in a strange script which is "<<
        endl << "unfamiliar to you.  You stare at the sign awhile longer,"<<
        endl << "but you cannot discern what it says." << endl;
      }
      else
      {
        cout << "Your Translate spell deciphers the sign's message." <<
        endl << "It says APOTHECARY." << endl;
      }
    }
    else if (!strcmp(token, "drink"))
      drink(wytch, token2, token3, 0);
    else if (!strcmp(token, "drop"))
    {
      wytch.removeInv(token2);
      rooms[4].insertItem(token2, 1);
    }

    else
      cout << "";
  }
  while(strcmp(breakloop, "bye") != 0);
}

/*********************************************************
 * init4(char string[])                                *
 * initialize the tokens to clear them out               *
 ********************************************************/
void init4(char string[])
{
  for (int i = 0; i < 10; i++)
    string[i] = '\0';
}


/*********************************************************
 * desc4()                                               *
 * Gives the room description                            *
 ********************************************************/
void desc4()
{
  cout << "You are in a cold hallway running north to south." <<
  endl << "There is a door to the west with a sign above it." <<
  endl;
}


/*********************************************************
 * look4()                                             *
 ********************************************************/
void look4(Myr wytch, char token2[], char token3[], char token4[])
{
  if (!strcmp(token2, "sign"))
  {
    if (wytch.retSpellState("Translate") == 0)
    {
      cout << "The sign is written in a strange script which is "<<
      endl << "unfamiliar to you.  You stare at the sign awhile longer,"<<
      endl << "but you cannot discern what it says." << endl;
    }
    else
    {
      cout << "Your Translate spell deciphers the sign's message." <<
      endl << "It says APOTHECARY." << endl;
    }
  }
  else if (!strcmp(token2, "door"))
  {
    cout << "You see no handle or other obvious means of opening this door." <<
    endl << "However, you see a series of numbers in a circle, acting as " <<
    endl << "a combination lock.  You must determine the next number in the "<<
    endl << "sequence to unlock the door." << endl;
  }
  else if (!strcmp(token2, "puzzle") || !strcmp(token2, "lock"))
  {
    cout << "On the door is a grid-like pattern with numbers scrawled into" << 
    endl << "into 8 of the 9 squares.  This puzzle acts as a combination " <<
    endl << "lock, where you must determine the pattern and what the missing" <<
    endl << "number is." << endl;
  }
  else if (!strcmp(token2, "ground") || !strcmp(token2, "floor"))
  {
    cout << "You scour the ground in hopes of finding something useful,"<<
    endl << "but your efforts end up producing nothing." << endl;
  }
  else if (!strcmp(token2, "room") || !strcmp(token2, "hallway"))
    desc4();
  else
    desc4();
}


/*********************************************************
 * open4(char [])
 ********************************************************/
void open4(char token2[], Room rooms[])
{ 
  int randomchoice = 0;
  int choice = 0;

  if (!strcmp(token2, "door"))
  {
    randomchoice = get_random(1, 3);
    cout << "You must figure out the correct number which is " <<
    endl << "missing to unlock the door." << endl;
  }
  else
    cout << "What are you trying to do?" << endl;

  if (randomchoice == 1)
  {
    cout << "-------------" <<
    endl << "| 9 | 6 | 3 |" <<
    endl << "-------------" <<
    endl << "| 1 |   | 6 |" <<
    endl << "-------------" <<
    endl << "| 7 | 2 | 8 |" <<
    endl << "-------------" <<
    endl << "What is the missing number > ";
    cin >> choice;
    if (choice == 17)
    {
      cout << "The door unlocks and opens by itself" << endl;
      rooms[4].doFunct(0, "unlockDoor");
      rooms[4].doFunct(0, "openDoor");
    }
    else
    {
      cout << "The door doesn't open.  Your guess must have been wrong."<<
      endl;
    }
  }

  if (randomchoice == 2)
  {
    cout << "-------------" <<
    endl << "| 3 | 3 | 1 |" <<
    endl << "-------------" <<
    endl << "| 2 |   | 6 |" <<
    endl << "-------------" <<
    endl << "| 2 | 5 | 0 |" <<
    endl << "-------------" <<
    endl << "What is the missing number > ";
    cin >> choice;
    if (choice == 7)
    {
      cout << "The door unlocks and opens by itself" << endl;
      rooms[4].doFunct(0, "unlockDoor");
      rooms[4].doFunct(0, "openDoor");
    }
    else
    {
      cout << "The door doesn't open.  Your guess must have been wrong."<<
      endl;
    }
  }

  if (randomchoice == 3)
  {
    cout << "-------------" <<
    endl << "| 6 | 2 | 4 |" <<
    endl << "-------------" <<
    endl << "| 6 |   | 3 |" <<
    endl << "-------------" <<
    endl << "| 0 | 7 | 5 |" <<
    endl << "-------------" <<
    endl << "What is the missing number > ";
    cin >> choice;
    if (choice == 12)
    {
      cout << "The door unlocks and opens by itself" << endl;
      rooms[4].doFunct(0, "unlockDoor");
      rooms[4].doFunct(0, "openDoor");
    }
    else
    {
      cout << "The door doesn't open.  Your guess must have been wrong."<<
      endl;
    }
  }

}

/*********************************************************
 * cast4()                                             *
 ********************************************************/
void cast4(Myr & wytch, char token2[], char token3[])
{
  int casted = 0; // initially the spell has not been cast yet

  // concatenate token2 & token 3
  if (strcmp(token3, "\0")) // if token is not NULL
  {
    strcat(token2, " ");
    strcat(token2, token3);
  }

  wytch.castSpell(token2, casted);

  if (casted == 1)
  {
    if (!strcmp(token2, "Unlock"))
    {
      cout << "To your dismay, your spell doesn't trigger the puzzle"<<
      endl << "lock." << endl;
    }
    else if (!strcmp(token2, "Translate"))
    {
      cout << "You cast the Translate spell.  You now have the " <<
      endl << "ability to read and understand languages unknown" <<
      endl << "to you." << endl;
    }
    else if (!strcmp(token2, "Sense"))
    {
      cout << "You cast your Sense spell, but you detect nothing " <<
              "unusual." << endl;
    }
    else if (!strcmp(token2, "Elixer"))
    {
      if (wytch.searchInv("boiling water") != 0)
      {
	cout << "You cast your spell over the flask of boiling water.  The"<<
	endl << "water settles and turns a slight rose color.  You now have"<<
	endl << "an Elixer which restores eight Life Points when consumed."<<
	endl;
	wytch.removeInv("boiling water");
	wytch.insertInv("elixer", 1);
      }
      else
      {
	cout << "You don't have any boiling water which is necessary to " <<
	endl << "complete the spell." << endl;
      }
    }
    else if (!strcmp(token2, "Mental Key"))
    {
      cout << "While your spell doesn't unlock the door, it does reveal"<<
      endl << "a clue how to unlock the door.  The missing number seems"<<
      endl << "to be the sum of one of the sides' numbers." << endl;
    }
    else
    {
      cout << "While your spell isn't useful here, you do get in " <<
              "some practice." << endl;
    }
  }
}
